/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.334 Revision 1.362
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.334 2010/02/26 03:15:26 abcd Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.362 2011/08/09 00:43:48 vapier Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
52} 52}
53 53
54else 54else
55 55
56ebeep() { 56ebeep() {
57 [[ $(type -t eqawarn) == function ]] && \
58 eqawarn "QA Notice: ebeep is not defined in EAPI=3, please file a bug at http://bugs.gentoo.org" 57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59} 58}
60 59
61epause() { 60epause() {
62 [[ $(type -t eqawarn) == function ]] && \
63 eqawarn "QA Notice: epause is not defined in EAPI=3, please file a bug at http://bugs.gentoo.org" 61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
64} 62}
65 63
64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to einfo for package managers that don't provide eqawarn and use the PM
70# implementation if available.
71if ! declare -F eqawarn >/dev/null ; then
72 eqawarn() {
73 einfo "$@"
74 }
66fi 75fi
67 76
68# @FUNCTION: ecvs_clean 77# @FUNCTION: ecvs_clean
69# @USAGE: [list of dirs] 78# @USAGE: [list of dirs]
70# @DESCRIPTION: 79# @DESCRIPTION:
191# If you do not specify any options, then epatch will default to the directory 200# If you do not specify any options, then epatch will default to the directory
192# specified by EPATCH_SOURCE. 201# specified by EPATCH_SOURCE.
193# 202#
194# When processing directories, epatch will apply all patches that match: 203# When processing directories, epatch will apply all patches that match:
195# @CODE 204# @CODE
196# ${EPATCH_FORCE} == "yes" 205# if ${EPATCH_FORCE} != "yes"
197# ??_${ARCH}_foo.${EPATCH_SUFFIX} 206# ??_${ARCH}_foo.${EPATCH_SUFFIX}
198# else 207# else
199# *.${EPATCH_SUFFIX} 208# *.${EPATCH_SUFFIX}
200# @CODE 209# @CODE
201# The leading ?? are typically numbers used to force consistent patch ordering. 210# The leading ?? are typically numbers used to force consistent patch ordering.
240 local EPATCH_SUFFIX=$1 249 local EPATCH_SUFFIX=$1
241 250
242 elif [[ -d $1 ]] ; then 251 elif [[ -d $1 ]] ; then
243 # Some people like to make dirs of patches w/out suffixes (vim) 252 # Some people like to make dirs of patches w/out suffixes (vim)
244 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"} 253 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
254
255 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
256 # Re-use EPATCH_SOURCE as a search dir
257 epatch "${EPATCH_SOURCE}/$1"
258 return $?
245 259
246 else 260 else
247 # sanity check ... if it isn't a dir or file, wtf man ? 261 # sanity check ... if it isn't a dir or file, wtf man ?
248 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1 262 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
249 echo 263 echo
280 # ???_arch_foo.patch 294 # ???_arch_foo.patch
281 # Else, skip this input altogether 295 # Else, skip this input altogether
282 local a=${patchname#*_} # strip the ???_ 296 local a=${patchname#*_} # strip the ???_
283 a=${a%%_*} # strip the _foo.patch 297 a=${a%%_*} # strip the _foo.patch
284 if ! [[ ${SINGLE_PATCH} == "yes" || \ 298 if ! [[ ${SINGLE_PATCH} == "yes" || \
285 ${EPATCH_FORCE} == "yes" || \ 299 ${EPATCH_FORCE} == "yes" || \
286 ${a} == all || \ 300 ${a} == all || \
287 ${a} == ${ARCH} ]] 301 ${a} == ${ARCH} ]]
288 then 302 then
289 continue 303 continue
290 fi 304 fi
291 305
292 # Let people filter things dynamically 306 # Let people filter things dynamically
349 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }') 363 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
350 if [[ -n ${abs_paths} ]] ; then 364 if [[ -n ${abs_paths} ]] ; then
351 count=1 365 count=1
352 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}" 366 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
353 fi 367 fi
368 # Similar reason, but with relative paths.
369 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
370 if [[ -n ${rel_paths} ]] ; then
371 eqawarn "QA Notice: Your patch uses relative paths '../'."
372 eqawarn " In the future this will cause a failure."
373 eqawarn "${rel_paths}"
374 fi
354 375
355 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/ 376 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
356 while [[ ${count} -lt 5 ]] ; do 377 while [[ ${count} -lt 5 ]] ; do
357 # Generate some useful debug info ... 378 # Generate some useful debug info ...
358 ( 379 (
359 _epatch_draw_line "***** ${patchname} *****" 380 _epatch_draw_line "***** ${patchname} *****"
360 echo 381 echo
361 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'" 382 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
362 echo 383 echo
363 _epatch_draw_line "***** ${patchname} *****" 384 _epatch_draw_line "***** ${patchname} *****"
385 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
386 ret=$?
387 echo
388 echo "patch program exited with status ${ret}"
389 exit ${ret}
364 ) >> "${STDERR_TARGET}" 390 ) >> "${STDERR_TARGET}"
365 391
366 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then 392 if [ $? -eq 0 ] ; then
367 ( 393 (
368 _epatch_draw_line "***** ${patchname} *****" 394 _epatch_draw_line "***** ${patchname} *****"
369 echo 395 echo
370 echo "ACTUALLY APPLYING ${patchname} ..." 396 echo "ACTUALLY APPLYING ${patchname} ..."
371 echo 397 echo
372 _epatch_draw_line "***** ${patchname} *****" 398 _epatch_draw_line "***** ${patchname} *****"
373 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1 399 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
400 ret=$?
401 echo
402 echo "patch program exited with status ${ret}"
403 exit ${ret}
374 ) >> "${STDERR_TARGET}" 404 ) >> "${STDERR_TARGET}"
375 405
376 if [ $? -ne 0 ] ; then 406 if [ $? -ne 0 ] ; then
377 echo 407 echo
378 eerror "A dry-run of patch command succeeded, but actually" 408 eerror "A dry-run of patch command succeeded, but actually"
409 done 439 done
410 440
411 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching" 441 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
412 : # everything worked 442 : # everything worked
413} 443}
444
445# @FUNCTION: epatch_user
446# @USAGE:
447# @DESCRIPTION:
448# Applies user-provided patches to the source tree. The patches are
449# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
450# of these three directories to exist will be the one to use, ignoring
451# any more general directories which might exist as well.
452#
453# User patches are intended for quick testing of patches without ebuild
454# modifications, as well as for permanent customizations a user might
455# desire. Obviously, there can be no official support for arbitrarily
456# patched ebuilds. So whenever a build log in a bug report mentions that
457# user patches were applied, the user should be asked to reproduce the
458# problem without these.
459#
460# Not all ebuilds do call this function, so placing patches in the
461# stated directory might or might not work, depending on the package and
462# the eclasses it inherits and uses. It is safe to call the function
463# repeatedly, so it is always possible to add a call at the ebuild
464# level. The first call is the time when the patches will be
465# applied.
466#
467# Ideally, this function should be called after gentoo-specific patches
468# have been applied, so that their code can be modified as well, but
469# before calls to e.g. eautoreconf, as the user patches might affect
470# autotool input files as well.
414epatch_user() { 471epatch_user() {
415 [[ $# -ne 0 ]] && die "epatch_user takes no options" 472 [[ $# -ne 0 ]] && die "epatch_user takes no options"
473
474 # Allow multiple calls to this function; ignore all but the first
475 local applied="${T}/epatch_user.applied"
476 [[ -e ${applied} ]] && return 2
416 477
417 # don't clobber any EPATCH vars that the parent might want 478 # don't clobber any EPATCH vars that the parent might want
418 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches 479 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
419 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do 480 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
420 EPATCH_SOURCE=${base}/${CTARGET}/${check} 481 EPATCH_SOURCE=${base}/${CTARGET}/${check}
424 EPATCH_SOURCE=${EPATCH_SOURCE} \ 485 EPATCH_SOURCE=${EPATCH_SOURCE} \
425 EPATCH_SUFFIX="patch" \ 486 EPATCH_SUFFIX="patch" \
426 EPATCH_FORCE="yes" \ 487 EPATCH_FORCE="yes" \
427 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \ 488 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
428 epatch 489 epatch
429 break 490 echo "${EPATCH_SOURCE}" > "${applied}"
491 return 0
430 fi 492 fi
431 done 493 done
494 echo "none" > "${applied}"
495 return 1
432} 496}
433 497
434# @FUNCTION: emktemp 498# @FUNCTION: emktemp
435# @USAGE: [temp dir] 499# @USAGE: [temp dir]
436# @DESCRIPTION: 500# @DESCRIPTION:
480egetent() { 544egetent() {
481 case ${CHOST} in 545 case ${CHOST} in
482 *-darwin[678]) 546 *-darwin[678])
483 case "$2" in 547 case "$2" in
484 *[!0-9]*) # Non numeric 548 *[!0-9]*) # Non numeric
485 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 549 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2\$/) {print \$0;exit;} }"
486 ;; 550 ;;
487 *) # Numeric 551 *) # Numeric
488 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 552 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
489 ;; 553 ;;
490 esac 554 esac
708 fi 772 fi
709 ;; 773 ;;
710 774
711 *) 775 *)
712 if [[ -z $@ ]] ; then 776 if [[ -z $@ ]] ; then
713 useradd ${opts} \ 777 useradd -r ${opts} \
714 -c "added by portage for ${PN}" \ 778 -c "added by portage for ${PN}" \
715 ${euser} \ 779 ${euser} \
716 || die "enewuser failed" 780 || die "enewuser failed"
717 else 781 else
718 einfo " - Extra: $@" 782 einfo " - Extra: $@"
719 useradd ${opts} "$@" \ 783 useradd -r ${opts} "$@" \
720 ${euser} \ 784 ${euser} \
721 || die "enewuser failed" 785 || die "enewuser failed"
722 fi 786 fi
723 ;; 787 ;;
724 esac 788 esac
837 esac 901 esac
838 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 902 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
839 ;; 903 ;;
840 904
841 *) 905 *)
906 # We specify -r so that we get a GID in the system range from login.defs
842 groupadd ${opts} ${egroup} || die "enewgroup failed" 907 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
843 ;; 908 ;;
844 esac 909 esac
845 export SANDBOX_ON="${oldsandbox}" 910 export SANDBOX_ON="${oldsandbox}"
846} 911}
847 912
858 923
859# Make a desktop file ! 924# Make a desktop file !
860# Great for making those icons in kde/gnome startmenu ! 925# Great for making those icons in kde/gnome startmenu !
861# Amaze your friends ! Get the women ! Join today ! 926# Amaze your friends ! Get the women ! Join today !
862# 927#
863# make_desktop_entry(<command>, [name], [icon], [type], [path]) 928# make_desktop_entry(<command>, [name], [icon], [type], [fields])
864# 929#
865# binary: what command does the app run with ? 930# binary: what command does the app run with ?
866# name: the name that will show up in the menu 931# name: the name that will show up in the menu
867# icon: give your little like a pretty little icon ... 932# icon: give your little like a pretty little icon ...
868# this can be relative (to /usr/share/pixmaps) or 933# this can be relative (to /usr/share/pixmaps) or
869# a full path to an icon 934# a full path to an icon
870# type: what kind of application is this ? for categories: 935# type: what kind of application is this ? for categories:
871# http://standards.freedesktop.org/menu-spec/latest/apa.html 936# http://standards.freedesktop.org/menu-spec/latest/apa.html
872# path: if your app needs to startup in a specific dir 937# fields: extra fields to append to the desktop file; a printf string
873make_desktop_entry() { 938make_desktop_entry() {
874 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 939 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
875 940
876 local exec=${1} 941 local exec=${1}
877 local name=${2:-${PN}} 942 local name=${2:-${PN}}
878 local icon=${3:-${PN}} 943 local icon=${3:-${PN}}
879 local type=${4} 944 local type=${4}
880 local path=${5} 945 local fields=${5}
881 946
882 if [[ -z ${type} ]] ; then 947 if [[ -z ${type} ]] ; then
883 local catmaj=${CATEGORY%%-*} 948 local catmaj=${CATEGORY%%-*}
884 local catmin=${CATEGORY##*-} 949 local catmin=${CATEGORY##*-}
885 case ${catmaj} in 950 case ${catmaj} in
886 app) 951 app)
887 case ${catmin} in 952 case ${catmin} in
888 accessibility) type=Accessibility;; 953 accessibility) type=Accessibility;;
889 admin) type=System;; 954 admin) type=System;;
890 antivirus) type=System;; 955 antivirus) type=System;;
891 arch) type=Archiving;; 956 arch) type=Archiving;;
892 backup) type=Archiving;; 957 backup) type=Archiving;;
893 cdr) type=DiscBurning;; 958 cdr) type=DiscBurning;;
894 dicts) type=Dictionary;; 959 dicts) type=Dictionary;;
895 doc) type=Documentation;; 960 doc) type=Documentation;;
896 editors) type=TextEditor;; 961 editors) type=TextEditor;;
897 emacs) type=TextEditor;; 962 emacs) type=TextEditor;;
898 emulation) type=Emulator;; 963 emulation) type=Emulator;;
899 laptop) type=HardwareSettings;; 964 laptop) type=HardwareSettings;;
900 office) type=Office;; 965 office) type=Office;;
901 pda) type=PDA;; 966 pda) type=PDA;;
902 vim) type=TextEditor;; 967 vim) type=TextEditor;;
903 xemacs) type=TextEditor;; 968 xemacs) type=TextEditor;;
904 *) type=;;
905 esac 969 esac
906 ;; 970 ;;
907 971
908 dev) 972 dev)
909 type="Development" 973 type="Development"
910 ;; 974 ;;
911 975
912 games) 976 games)
913 case ${catmin} in 977 case ${catmin} in
914 action|fps) type=ActionGame;; 978 action|fps) type=ActionGame;;
915 arcade) type=ArcadeGame;; 979 arcade) type=ArcadeGame;;
916 board) type=BoardGame;; 980 board) type=BoardGame;;
917 emulation) type=Emulator;; 981 emulation) type=Emulator;;
918 kids) type=KidsGame;; 982 kids) type=KidsGame;;
919 puzzle) type=LogicGame;; 983 puzzle) type=LogicGame;;
920 roguelike) type=RolePlaying;; 984 roguelike) type=RolePlaying;;
921 rpg) type=RolePlaying;; 985 rpg) type=RolePlaying;;
922 simulation) type=Simulation;; 986 simulation) type=Simulation;;
923 sports) type=SportsGame;; 987 sports) type=SportsGame;;
924 strategy) type=StrategyGame;; 988 strategy) type=StrategyGame;;
925 *) type=;;
926 esac 989 esac
927 type="Game;${type}" 990 type="Game;${type}"
928 ;; 991 ;;
929 992
930 gnome) 993 gnome)
939 type="Network;Email" 1002 type="Network;Email"
940 ;; 1003 ;;
941 1004
942 media) 1005 media)
943 case ${catmin} in 1006 case ${catmin} in
1007 gfx)
944 gfx) type=Graphics;; 1008 type=Graphics
1009 ;;
1010 *)
1011 case ${catmin} in
945 radio) type=Tuner;; 1012 radio) type=Tuner;;
946 sound) type=Audio;; 1013 sound) type=Audio;;
947 tv) type=TV;; 1014 tv) type=TV;;
948 video) type=Video;; 1015 video) type=Video;;
949 *) type=;; 1016 esac
1017 type="AudioVideo;${type}"
1018 ;;
950 esac 1019 esac
951 type="AudioVideo;${type}"
952 ;; 1020 ;;
953 1021
954 net) 1022 net)
955 case ${catmin} in 1023 case ${catmin} in
956 dialup) type=Dialup;; 1024 dialup) type=Dialup;;
957 ftp) type=FileTransfer;; 1025 ftp) type=FileTransfer;;
958 im) type=InstantMessaging;; 1026 im) type=InstantMessaging;;
959 irc) type=IRCClient;; 1027 irc) type=IRCClient;;
960 mail) type=Email;; 1028 mail) type=Email;;
961 news) type=News;; 1029 news) type=News;;
962 nntp) type=News;; 1030 nntp) type=News;;
963 p2p) type=FileTransfer;; 1031 p2p) type=FileTransfer;;
964 voip) type=Telephony;; 1032 voip) type=Telephony;;
965 *) type=;;
966 esac 1033 esac
967 type="Network;${type}" 1034 type="Network;${type}"
968 ;; 1035 ;;
969 1036
970 sci) 1037 sci)
971 case ${catmin} in 1038 case ${catmin} in
972 astro*) type=Astronomy;; 1039 astro*) type=Astronomy;;
973 bio*) type=Biology;; 1040 bio*) type=Biology;;
974 calc*) type=Calculator;; 1041 calc*) type=Calculator;;
975 chem*) type=Chemistry;; 1042 chem*) type=Chemistry;;
976 elec*) type=Electronics;; 1043 elec*) type=Electronics;;
977 geo*) type=Geology;; 1044 geo*) type=Geology;;
978 math*) type=Math;; 1045 math*) type=Math;;
979 physics) type=Physics;; 1046 physics) type=Physics;;
980 visual*) type=DataVisualization;; 1047 visual*) type=DataVisualization;;
981 *) type=;;
982 esac 1048 esac
983 type="Education;Science;${type}" 1049 type="Education;Science;${type}"
984 ;; 1050 ;;
985 1051
986 sys) 1052 sys)
988 ;; 1054 ;;
989 1055
990 www) 1056 www)
991 case ${catmin} in 1057 case ${catmin} in
992 client) type=WebBrowser;; 1058 client) type=WebBrowser;;
993 *) type=;;
994 esac 1059 esac
995 type="Network;${type}" 1060 type="Network;${type}"
996 ;; 1061 ;;
997 1062
998 *) 1063 *)
1010 1075
1011 # Don't append another ";" when a valid category value is provided. 1076 # Don't append another ";" when a valid category value is provided.
1012 type=${type%;}${type:+;} 1077 type=${type%;}${type:+;}
1013 1078
1014 eshopts_push -s extglob 1079 eshopts_push -s extglob
1015 if [[ -n ${icon} && ${icon} != /* && ${icon} == *.@(xpm|png|svg) ]]; then 1080 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1016 ewarn "As described in the Icon Theme Specification, icon file extensions are not" 1081 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1017 ewarn "allowed in .desktop files if the value is not an absolute path." 1082 ewarn "allowed in .desktop files if the value is not an absolute path."
1018 icon=${icon%.@(xpm|png|svg)} 1083 icon=${icon%.@(xpm|png|svg)}
1019 fi 1084 fi
1020 eshopts_pop 1085 eshopts_pop
1028 TryExec=${exec%% *} 1093 TryExec=${exec%% *}
1029 Icon=${icon} 1094 Icon=${icon}
1030 Categories=${type} 1095 Categories=${type}
1031 EOF 1096 EOF
1032 1097
1033 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 1098 if [[ ${fields:-=} != *=* ]] ; then
1099 # 5th arg used to be value to Path=
1100 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1101 fields="Path=${fields}"
1102 fi
1103 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
1034 1104
1035 ( 1105 (
1036 # wrap the env here so that the 'insinto' call 1106 # wrap the env here so that the 'insinto' call
1037 # doesn't corrupt the env of the caller 1107 # doesn't corrupt the env of the caller
1038 insinto /usr/share/applications 1108 insinto /usr/share/applications
1039 doins "${desktop}" 1109 doins "${desktop}"
1040 ) 1110 ) || die "installing desktop file failed"
1041} 1111}
1042 1112
1043# @FUNCTION: validate_desktop_entries 1113# @FUNCTION: validate_desktop_entries
1044# @USAGE: [directories] 1114# @USAGE: [directories]
1045# @MAINTAINER: 1115# @MAINTAINER:
1324 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1394 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1325 1395
1326 local shrtsrc=$(basename "${src}") 1396 local shrtsrc=$(basename "${src}")
1327 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1397 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1328 if [[ -z ${skip} ]] ; then 1398 if [[ -z ${skip} ]] ; then
1329 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1399 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1330 local skip=0 1400 local skip=0
1331 exe=tail 1401 exe=tail
1332 case ${ver} in 1402 case ${ver} in
1333 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1403 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1334 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1404 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1336 2.0|2.0.1) 1406 2.0|2.0.1)
1337 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1407 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1338 ;; 1408 ;;
1339 2.1.1) 1409 2.1.1)
1340 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1410 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1341 let skip="skip + 1" 1411 (( skip++ ))
1342 ;; 1412 ;;
1343 2.1.2) 1413 2.1.2)
1344 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1414 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1345 let skip="skip + 1" 1415 (( skip++ ))
1346 ;; 1416 ;;
1347 2.1.3) 1417 2.1.3)
1348 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1418 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1349 let skip="skip + 1" 1419 (( skip++ ))
1350 ;; 1420 ;;
1351 2.1.4|2.1.5) 1421 2.1.4|2.1.5)
1352 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1422 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1353 skip=$(head -n ${skip} "${src}" | wc -c) 1423 skip=$(head -n ${skip} "${src}" | wc -c)
1354 exe="dd" 1424 exe="dd"
1363 esac 1433 esac
1364 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1434 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1365 fi 1435 fi
1366 case ${exe} in 1436 case ${exe} in
1367 tail) exe="tail -n +${skip} '${src}'";; 1437 tail) exe="tail -n +${skip} '${src}'";;
1368 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1438 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1369 *) die "makeself cant handle exe '${exe}'" 1439 *) die "makeself cant handle exe '${exe}'"
1370 esac 1440 esac
1371 1441
1372 # lets grab the first few bytes of the file to figure out what kind of archive it is 1442 # lets grab the first few bytes of the file to figure out what kind of archive it is
1373 local tmpfile=$(emktemp) 1443 local filetype tmpfile=$(emktemp)
1374 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1444 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1375 local filetype=$(file -b "${tmpfile}") 1445 filetype=$(file -b "${tmpfile}") || die
1376 case ${filetype} in 1446 case ${filetype} in
1377 *tar\ archive*) 1447 *tar\ archive*)
1378 eval ${exe} | tar --no-same-owner -xf - 1448 eval ${exe} | tar --no-same-owner -xf -
1379 ;; 1449 ;;
1380 bzip2*) 1450 bzip2*)
1506 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1576 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1507 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1577 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1508 export CDROM_SET=-1 1578 export CDROM_SET=-1
1509 for f in ${CDROM_CHECK_1//:/ } ; do 1579 for f in ${CDROM_CHECK_1//:/ } ; do
1510 ((++CDROM_SET)) 1580 ((++CDROM_SET))
1511 [[ -e ${CD_ROOT}/${f} ]] && break 1581 [[ -e ${CDROM_ROOT}/${f} ]] && break
1512 done 1582 done
1513 export CDROM_MATCH=${f} 1583 export CDROM_MATCH=${f}
1514 return 1584 return
1515 fi 1585 fi
1516 1586
1690 else 1760 else
1691 newls="" 1761 newls=""
1692 fi 1762 fi
1693 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do 1763 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1694 if [[ ${op} == "-i" ]] ; then 1764 if [[ ${op} == "-i" ]] ; then
1695 hasq ${f} ${ls} && newls="${newls} ${f}" 1765 has ${f} ${ls} && newls="${newls} ${f}"
1696 else 1766 else
1697 hasq ${f} ${ls} || newls="${newls} ${f}" 1767 has ${f} ${ls} || newls="${newls} ${f}"
1698 fi 1768 fi
1699 done 1769 done
1700 ls=${newls} 1770 ls=${newls}
1701 done 1771 done
1702 else 1772 else
1704 fi 1774 fi
1705 1775
1706 nols="" 1776 nols=""
1707 newls="" 1777 newls=""
1708 for f in ${LINGUAS} ; do 1778 for f in ${LINGUAS} ; do
1709 if hasq ${f} ${ls} ; then 1779 if has ${f} ${ls} ; then
1710 newls="${newls} ${f}" 1780 newls="${newls} ${f}"
1711 else 1781 else
1712 nols="${nols} ${f}" 1782 nols="${nols} ${f}"
1713 fi 1783 fi
1714 done 1784 done
1769 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1839 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1770 ewarn "in order to remove these old dependencies. If you do not have this" 1840 ewarn "in order to remove these old dependencies. If you do not have this"
1771 ewarn "helper program, simply emerge the 'gentoolkit' package." 1841 ewarn "helper program, simply emerge the 'gentoolkit' package."
1772 ewarn 1842 ewarn
1773 fi 1843 fi
1844 # temp hack for #348634 #357225
1845 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1774 ewarn " # revdep-rebuild --library ${lib##*/}" 1846 ewarn " # revdep-rebuild --library '${lib}'"
1775 done 1847 done
1776 if [[ ${notice} -eq 1 ]] ; then 1848 if [[ ${notice} -eq 1 ]] ; then
1777 ewarn 1849 ewarn
1778 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1850 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1779 ewarn "delete the old libraries. Here is a copy & paste for the lazy:" 1851 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1925 else 1997 else
1926 newbin "${tmpwrapper}" "${wrapper}" || die 1998 newbin "${tmpwrapper}" "${wrapper}" || die
1927 fi 1999 fi
1928} 2000}
1929 2001
1930# @FUNCTION: prepalldocs 2002# @FUNCTION: path_exists
1931# @USAGE: 2003# @USAGE: [-a|-o] <paths>
1932# @DESCRIPTION: 2004# @DESCRIPTION:
1933# Compress files in /usr/share/doc which are not already 2005# Check if the specified paths exist. Works for all types of paths
1934# compressed, excluding /usr/share/doc/${PF}/html. 2006# (files/dirs/etc...). The -a and -o flags control the requirements
1935# Uses the ecompressdir to do the compression. 2007# of the paths. They correspond to "and" and "or" logic. So the -a
1936# 2009-02-18 by betelgeuse: 2008# flag means all the paths must exist while the -o flag means at least
1937# Commented because ecompressdir is even more internal to 2009# one of the paths must exist. The default behavior is "and". If no
1938# Portage than prepalldocs (it's not even mentioned in man 5 2010# paths are specified, then the return value is "false".
1939# ebuild). Please submit a better version for review to gentoo-dev 2011path_exists() {
1940# if you want prepalldocs here. 2012 local opt=$1
1941#prepalldocs() { 2013 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1942# if [[ -n $1 ]] ; then
1943# ewarn "prepalldocs: invalid usage; takes no arguments"
1944# fi
1945 2014
1946# cd "${D}" 2015 # no paths -> return false
1947# [[ -d usr/share/doc ]] || return 0 2016 # same behavior as: [[ -e "" ]]
2017 [[ $# -eq 0 ]] && return 1
1948 2018
1949# find usr/share/doc -exec gzip {} + 2019 local p r=0
1950# ecompressdir --ignore /usr/share/doc/${PF}/html 2020 for p in "$@" ; do
1951# ecompressdir --queue /usr/share/doc 2021 [[ -e ${p} ]]
1952#} 2022 : $(( r += $? ))
2023 done
2024
2025 case ${opt} in
2026 -a) return $(( r != 0 )) ;;
2027 -o) return $(( r == $# )) ;;
2028 esac
2029}

Legend:
Removed from v.1.334  
changed lines
  Added in v.1.362

  ViewVC Help
Powered by ViewVC 1.1.20